#include <iostream>

using namespace std;

int main()
{
    int N,k,niz[N*N];
    cin>>N>>k;
    for(int i=0; i<N*N; i++)
    {
        cin>>niz[i];
    }
    for(int j=1; j<=k; j++)
    {
        int poz[N*N],c=0;
        for(int i=0; i<N*N; i++)
        {
            if(j==niz[i])
            {
                poz[c]=i;
                c++;
            }
        }
        for(int i=0; i<N*N; i++)
        {
            while(poz[i]>N)
            {
                poz[i]=poz[i]-N;
            }
        }
        int brojac=1,br=0;
        int zbir=0;
        while(poz[0]=!poz[brojac])
        {
            brojac++;
        }
        if(c%brojac==0)
        {
            for(int i=0; i<brojac; i++)
            {
                for(int j=1; j<(c/brojac); j++)
                {
                    if(poz[i]==poz[(brojac*j)+i])
                    {
                        br=1;
                    }
                    else
                    {
                        br=0;
                    }
                }
            }
            zbir=zbir+br;

        }
    }
    cout<<zbir<<endl;